{% extends "base.html" %}
{%- import "common/macros/generic.html" as mg -%}


{% block head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datatables.css",
        "css/plugins/jquery.datatables.bootstrap4.min.css",
        "css/plugins/jquery.datatables.utils.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% block sub_head %}{% endblock %}
{% endblock %}


{% block content_main %}
    {% set module_name = request.mod|normalize|title %}
    <div id="details" class="modal fade">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Transaction Details</h5>
                </div>
                <div class="modal-body">

                </div>
            </div>
        </div>
    </div>
    <div class="card">
        <div class="card-header">
            <div class="row">
                <div class="col-12 col-md-6 col-xl-7">
                    <nav aria-label="breadcrumb">
                        <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                            <li class="breadcrumb-item"><a href="{{ url_for('.index') }}">{{ module_name }}</a></li>
                            <li class="breadcrumb-item"><a href="{{ url_for('.edit', _id=record._id) }}">{{ record.product_code }}</a></li>
                            <li class="breadcrumb-item active"> Stock Card</li>
                        </ol>
                    </nav>
                </div>
                <div class="col-12 col-md-6 col-xl-5 text-right">
                    <div class="row">
                        <div class="col"></div>
                        <div class="col">
                            <a href="{{ url_for('.index') }}" class="btn btn-danger btn-sm btn-block my-2 my-md-1"><i class="fa fa-fw fa-arrow-left"></i> Go Back</a>
                        </div>
                    </div>
                </div>
            </div>
            <h4 class="card-title mt-1 mt-md-0"> Stock Card</h4>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-md-6">
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label>{{ "product_code"|normalize|title }}</label>
                                <input type="text" class="form-control" value="{{ record.product_code }}" readonly />
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label>{{ "description"|normalize|title }}</label>
                                <input type="text" class="form-control" value="{{ record.description }}" readonly />
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 col-md-6">
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label>{{ "current_stock_on_hand"|normalize|title }}</label>
                                <input type="text" class="form-control" value="{{ record.stock_on_hand }}" readonly />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <table class="table table-striped table-hover table-bordered">
                        <thead>
                            <tr>
                                {% for column in STOCK_CARD_DATA_COLUMNS %}
                                    {% if column.hidden is undefined %}
                                        <th>{{ column.label }}</th>
                                    {% endif %}
                                {% endfor %}
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block scripts %}
    {% assets
        filters="rjsmin",
        output="compressed/datatables.js",
        "js/plugins/jquery.datatables.min.js",
        "js/plugins/jquery.datatables.bootstrap4.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <script>
        merge_objects($dom, {
            tables: {
                stock_card: $('table.table')
            },
            modals: {
                details: $('#details.modal')
            },
            datatables: {}
        });

        $('#details').on('hide.bs.modal', function() {
            $(this).find('.modal-body').html('');
        });

        $dom.tables.stock_card.on('click', '[data-location]', function() {
            $dom.modals.details.find('.modal-body').html(`
                <p><strong>Transaction Date:</strong> {0}</p>
                <p><strong>Facilitated by:</strong> {1}</p>
                <hr>
                <p><strong>Quantity:</strong> {2}</p>
                <p><strong>Location:</strong> {3}</p>
                <p><strong>Manufacturing Date:</strong> {4}</p>
                <p><strong>Expiration Date:</strong> {5}</p>
            `.format(
                $(this).data('date-created'),
                $(this).data('created-by'),
                $(this).data('quantity'),
                $(this).data('location'),
                $(this).data('manufacturing-date'),
                $(this).data('expiry-date')
            ));
            $dom.modals.details.modal('show');
        });

        // $dom.datatables.stock_card.on('click', '[data-price-per-unit]', function() {
        //     $('#details').modal.show();
        // });

        {# SECTION: Datatable #}
        let datatable_options = {
            dom: 'rt<"row"<"col-12 col-md-4 col-xl-3"l><"col-12 col-md-8 col-xl-9"p>><"row"<"col-12 text-center"i>>',
            order: [[0, 'desc']],
            autoWidth: false,
            responsive: true,
            stateSave: true,
            serverSide: true,
            deferLoading: true,
            lengthMenu: [[25, 50, 100, -1], ['25 Records', '50 Records', '100 Records', 'All Records']],
            ajax: {
                url: '{{ url_for(".load_stock_card", _id=record._id) }}',
                type: 'POST',
                dataType: 'json'
            },
            columns: [
                {
                    data: 'date_created'
                },
                {
                    data: 'type',
                    render: function(_, type, data) {
                        let label = data.type.replace('_', ' ').titleCase();
                        if (data.type === 'stock_transfer') {
                            return '<span>{0} <a href="#" data-date-created="{1}" data-created-by="{2}" data-quantity="{3}" data-location="{4}" data-manufacturing-date="{5}" data-expiry-date="{6}"><i class="fa fa-fw fa-question-circle"></i></a></span>'.format(
                                label,
                                data.date_created,
                                data.created_by,
                                Math.abs(data.quantity),
                                data.location,
                                data.manufacturing_date,
                                data.expiry_date
                            );
                        }
                        else {
                            return '<span>{0} <a href="#" data-created-by="{1}" data-price-per-unit="{2}"><i class="fa fa-fw fa-question-circle"></i></a></span>'.format(
                                label,
                                data.created_by,
                                Math.abs(data.quantity),
                                data.price_per_unit
                            );
                        }
                    },
                    orderable: false
                },
                {
                    data: 'quantity',
                    render: function(data) {
                        return (data == 0) ? '--' : (data > 0) ? data : '--'.format(data);
                    },
                    orderable: false
                },
                {
                    data: 'quantity',
                    render: function(data) {
                        return (data == 0) ? '--' : (data < 0) ? data : '--'.format(data);
                    },
                    orderable: false
                },
                {
                    data: 'location',
                    render: function(data) {
                        return (data == null) ? '--' : data;
                    },
                    orderable: false
                },
                {
                    data: 'price_per_unit',
                    render: function(data) {
                        if (isDefined(data)) {
                            return (data == 0) ? '--' : (data > 0) ? data : '({0})'.format(data);
                        } else {
                            return '--';
                        }
                    },
                    orderable: false
                }
            ],
            rowId: '_id',
            initComplete: function() {
                $dom.document.find('.dataTables_info').addClass('text-muted');
            },
            preDrawCallback: function() {

            },
            drawCallback: function() {

            }
        }
        $dom.datatables.stock_card = $dom.tables.stock_card.DataTable(datatable_options);

        $dom.datatables.stock_card.reload = function(search) {
            $dom.datatables.stock_card.ajax.reload(function() {
                if (!isDefined(search)) {
                }
            });
        }
        {# END: Datatable #}

        $dom.document.ready(function() {
            $dom.datatables.stock_card.reload();
        });
    </script>
{% endblock %}
